pfSense - Feature #7016

system_information_widget.php - Indicate adaptive state timeout status when active
12/16/2016 01:44 PM - Jim Pingle

Status: Resolved Start date: 12/16/2016
Priority: Normal Due date:

Assignee: Steve Beaver % Done: 0%
Category: Dashboard Estimated time: 0.00 hour
Target version: 250

Plus Target Version: Release Notes: Default
Description

It would be helpful to show the user that pf has enabled adaptive state timeout scaling when it kicks in.

Some sample code to calculate the scaling factor and to flag when it is active:

if (isset ($config['system']['adaptivestart']) and $config['system']['adaptivestart'] > 0) {
Sadaptivestart = "{$config['system']['adaptivestart']}";

} else {
Sadaptivestart = intval ($maxstates * 0.6);

}

if (isset ($config['system']['adaptiveend']) and $config['system']['adaptiveend'] > 0) {
Sadaptiveend = "{S$config['system']['adaptiveend']}";

} else {

Sadaptiveend = intval ($maxstates * 1.2);

}

Sadaptive_text = "";
if (Scurentries > S$Sadaptivestart) {

Sscalingfactor = round(($adaptiveend - S$curentries) / ($Sadaptiveend - $adaptivestart) * 100, O
)i

Sadaptive_text = "Adaptive state handling enabled, state timeouts reduced by {$scalingfactor}%

)"
}

Main problem is formatting in the widget, getting it to a place where it's clear what it is without cluttering. Bonus points for changing
the color of the progress bar to yellow when this is active.

History

#1 - 10/06/2020 09:52 AM - Steve Beaver
- Assignee set to Jim Pingle

- Private changed from No to Yes

Suggest move this to factory

#2 - 10/06/2020 10:34 AM - Steve Beaver

- Assignee changed from Jim Pingle to Steve Beaver
#3 - 10/16/2020 11:47 AM - Steve Beaver
- Status changed from New to Feedback

- Assignee changed from Steve Beaver to Jim Pingle

Implemented as requested
#4 - 10/19/2020 01:31 PM - Jim Pingle
- Status changed from Feedback to In Progress

- Assignee changed from Jim Pingle to Steve Beaver

A few problems as it is implemented:

1. It doesn't work because it's checking $curentries not $pfstatetext

2. $pfstatetext isn't populated a the time of the check, it needs to be moved up from where it is set

3. It only takes effect when the page is loaded, not dynamically when the widget is refreshed via JS. If the threshold is exceeded and the page isn't
reloaded, the user wouldn't see the change in color. | thought the thermal sensors widget updated dynamically like that but | don't have a simple way
to confirm that at the moment.

#5 - 10/20/2020 07:05 AM - Steve Beaver

Logic has been updated but only on initial page load. Once this has been tested and confirmed as satisfactory | will add the Ajax magic.

#6 - 10/20/2020 09:04 AM - Jim Pingle

- Private changed from Yes to No

Seems to also be susceptible to a PHP error, the code can end up dividing by 0: #10993

#7 - 10/20/2020 10:31 AM - Steve Beaver

- Assignee changed from Steve Beaver to Jim Pingle

Functionality has been finalized by adding the required data and providing the needed Ajax logic.

#8 - 10/20/2020 01:08 PM - Jim Pingle

- Assignee changed from Jim Pingle to Steve Beaver

I'm still only seeing the label and color change if | reload the page with a high state count. If | change the state count without reloading the page, the
value changes as before but the color and labels stay the same.

#9 - 10/20/2020 01:54 PM - Steve Beaver

Number format corrected

#10 - 10/20/2020 01:54 PM - Steve Beaver

- Assignee changed from Steve Beaver to Jim Pingle

#11 - 10/20/2020 03:11 PM - Jim Pingle

- Status changed from In Progress to Resolved

Looks good after a gitsync

#12 - 10/20/2020 03:11 PM - Jim Pingle

- Assignee changed from Jim Pingle to Steve Beaver
